local AddOn, _DUF = ...

local find = string.find

local function Update_All_NewSettings() -- Should only be called once, see _DUF:DUF_Initialize_NewSettings() at the bottom
	--TigerHeart
	if (not DUF_Settings[DUF_INDEX].focus) then
		DUF_Settings[DUF_INDEX].focus = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX].targettarget, DUF_Settings[DUF_INDEX].focus);
		DUF_Settings[DUF_INDEX].focus.hide = true;
		DUF_Settings[DUF_INDEX].focus.ComboPoints = nil;
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.0"]) then
		DUF_Settings[DUF_INDEX].target.ComboPoints.xoffset = DUF_Settings[DUF_INDEX].ComboOffset.x;
		DUF_Settings[DUF_INDEX].target.ComboPoints.yoffset = DUF_Settings[DUF_INDEX].ComboOffset.y;
		DUF_Settings[DUF_INDEX].ComboOffset.y = nil;
		DUF_Settings[DUF_INDEX].ComboOffset.x = nil;
		DUF_Settings[DUF_INDEX].optionscale = 1;
		DUF_Settings[DUF_INDEX].updatespeed = 1 / 30;
		DUF_Settings[DUF_INDEX].updatespeedbase = 30;
		DUF_Settings[DUF_INDEX].flashthreshold = .1;
		DUF_Settings[DUF_INDEX].healththreshold1 = .6;
		DUF_Settings[DUF_INDEX].healththreshold2 = .3;
		DUF_Settings[DUF_INDEX].healthcolor1 = { r=1, g=1, b=0 };
		DUF_Settings[DUF_INDEX].healthcolor2 = { r=1, g=0, b=0 };
		DUF_Settings[DUF_INDEX].manathreshold1 = .6;
		DUF_Settings[DUF_INDEX].manathreshold2 = .3;
		DUF_Settings[DUF_INDEX].manacolor1 = { r=1, g=1, b=0 };
		DUF_Settings[DUF_INDEX].manacolor2 = { r=1, g=0, b=0 };
		DUF_Settings[DUF_INDEX].targettarget = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX].target, DUF_Settings[DUF_INDEX].targettarget);
		DUF_Settings[DUF_INDEX].targettarget.hide = true;
		DUF_Settings[DUF_INDEX].targettarget.ComboPoints = nil;

		--TigerHeart
		DUF_Settings[DUF_INDEX].focus = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX].targettarget, DUF_Settings[DUF_INDEX].focus);
		DUF_Settings[DUF_INDEX].focus.hide = true;
		DUF_Settings[DUF_INDEX].focus.ComboPoints = nil;

		DUF_Settings[DUF_INDEX].pet.StatusBar[3] = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.StatusBar[3], DUF_Settings[DUF_INDEX].pet.StatusBar[3]);
		DUF_Settings[DUF_INDEX].pet.StatusBar[3].hide = true;
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				DUF_Settings[DUF_INDEX][unit].RaceIcon = {};
				DL_Copy_Table(DUF_Settings[DUF_INDEX][unit].ClassIcon, DUF_Settings[DUF_INDEX][unit].RaceIcon);
				DUF_Settings[DUF_INDEX][unit].RaceIcon.hide = true;
				DUF_Settings[DUF_INDEX][unit].backgroundstyle = 2;
				DUF_Settings[DUF_INDEX][unit].bgalpha = 1;
				DUF_Settings[DUF_INDEX][unit].bgcolor.a = nil;
				DUF_Settings[DUF_INDEX][unit].bordercolor.a = nil;
				DUF_Settings[DUF_INDEX][unit].bgpadding = 5;
				DUF_Settings[DUF_INDEX][unit].Buffs.spacing = 0;
				DUF_Settings[DUF_INDEX][unit].Debuffs.spacing = 0;
				DUF_Settings[DUF_INDEX][unit].Buffs.bordercolor = {r=1, g=1, b=1};
				DUF_Settings[DUF_INDEX][unit].Debuffs.bordercolor = {r=1, g=1, b=1};
				if (DUF_Settings[DUF_INDEX][unit].context == "Reaction") then
					DUF_Settings[DUF_INDEX][unit].context = 2;
				elseif (DUF_Settings[DUF_INDEX][unit].context == "Difficulty") then
					DUF_Settings[DUF_INDEX][unit].context = 1;
				elseif (DUF_Settings[DUF_INDEX][unit].context == "Class") then
					DUF_Settings[DUF_INDEX][unit].context = 3;
				else
					DUF_Settings[DUF_INDEX][unit].context = nil;
				end
				if (DUF_Settings[DUF_INDEX][unit].recolor) then
					DUF_Settings[DUF_INDEX][unit].bgcontext = 4;
				end
				DUF_Settings[DUF_INDEX][unit].StatusBar[4] = {};
				DUF_Settings[DUF_INDEX][unit].StatusBar[5] = {};
				DL_Copy_Table(DUF_Settings[DUF_INDEX][unit].StatusBar[1], DUF_Settings[DUF_INDEX][unit].StatusBar[4]);
				DL_Copy_Table(DUF_Settings[DUF_INDEX][unit].StatusBar[2], DUF_Settings[DUF_INDEX][unit].StatusBar[5]);
				DUF_Settings[DUF_INDEX][unit].StatusBar[4].hide = true;
				DUF_Settings[DUF_INDEX][unit].StatusBar[5].hide = true;
				DUF_Settings[DUF_INDEX][unit].leftclick = 1;
				DUF_Settings[DUF_INDEX][unit].rightclick = 3;
				DUF_Settings[DUF_INDEX][unit].middleclick = 2;
				DUF_Settings[DUF_INDEX][unit].connectmethod = 1;
				DUF_Settings[DUF_INDEX][unit].spacing = 0;
				for _,element in pairs(DUF_ELEMENT_INDICES) do
					if (element == "TextBox") then
						for i=1,10 do
							DUF_Settings[DUF_INDEX][unit][element][i].backgroundstyle = 1;
							DUF_Settings[DUF_INDEX][unit][element][i].bgalpha = 1;
							if (not DUF_Settings[DUF_INDEX][unit][element][i].borderalpha) then
								DUF_Settings[DUF_INDEX][unit][element][i].borderalpha = 1;
							end
							DUF_Settings[DUF_INDEX][unit][element][i].bgcolor.a = nil;
							DUF_Settings[DUF_INDEX][unit][element][i].bordercolor.a = nil;
							DUF_Settings[DUF_INDEX][unit][element][i].bgpadding = 1;
							DUF_Settings[DUF_INDEX][unit][element][i].font = 1;
							DUF_Settings[DUF_INDEX][unit][element][i].justifyV = "CENTER";
							if (not DUF_Settings[DUF_INDEX][unit][element][i].showbg) then
								DUF_Settings[DUF_INDEX][unit][element][i].hidebg = true;
							end
							DUF_Settings[DUF_INDEX][unit][element][i].showbg = nil;
							if (DUF_Settings[DUF_INDEX][unit][element][i].context == "Reaction") then
								DUF_Settings[DUF_INDEX][unit][element][i].context = 2;
							elseif (DUF_Settings[DUF_INDEX][unit][element][i].context == "Difficulty") then
								DUF_Settings[DUF_INDEX][unit][element][i].context = 1;
							elseif (DUF_Settings[DUF_INDEX][unit][element][i].context == "Class") then
								DUF_Settings[DUF_INDEX][unit][element][i].context = 3;
							else
								DUF_Settings[DUF_INDEX][unit].context = nil;
							end
							if (not DUF_Settings[DUF_INDEX][unit][element][i].mouseovercolor) then
								DUF_Settings[DUF_INDEX][unit][element][i].mouseovercolor = {r=1, g=1, b=0};
							end
							DUF_Settings[DUF_INDEX][unit][element][i].attach = "Unit Frame";
							DUF_Settings[DUF_INDEX][unit][element][i].attachpoint = "TOPLEFT";
							DUF_Settings[DUF_INDEX][unit][element][i].attachto = "TOPLEFT";
							DUF_Settings[DUF_INDEX][unit][element][i].leftclick = 1;
							DUF_Settings[DUF_INDEX][unit][element][i].rightclick = 3;
							DUF_Settings[DUF_INDEX][unit][element][i].middleclick = 2;
						end
					elseif (element == "StatusBar") then
						for i=1,6 do
							if (DUF_Settings[DUF_INDEX][unit][element][i]) then
								DUF_Settings[DUF_INDEX][unit][element][i].backgroundstyle = 1;
								DUF_Settings[DUF_INDEX][unit][element][i].bgalpha = 1;
								DUF_Settings[DUF_INDEX][unit][element][i].bgcolor.a = nil;
								DUF_Settings[DUF_INDEX][unit][element][i].bordercolor.a = nil;
								DUF_Settings[DUF_INDEX][unit][element][i].bgpadding = 1;
								DUF_Settings[DUF_INDEX][unit][element][i].color2 = {r=1, g=1, b=0};
								DUF_Settings[DUF_INDEX][unit][element][i].attach = "Unit Frame";
								DUF_Settings[DUF_INDEX][unit][element][i].attachpoint = "TOPLEFT";
								DUF_Settings[DUF_INDEX][unit][element][i].attachto = "TOPLEFT";
								DUF_Settings[DUF_INDEX][unit][element][i].leftclick = 1;
								DUF_Settings[DUF_INDEX][unit][element][i].rightclick = 3;
								DUF_Settings[DUF_INDEX][unit][element][i].middleclick = 2;
								if (not DUF_Settings[DUF_INDEX][unit][element][i].mouseovercolor) then
									DUF_Settings[DUF_INDEX][unit][element][i].mouseovercolor = {r=1, g=1, b=0};
								end
								if (DUF_Settings[DUF_INDEX][unit][element][i].recolor) then
									if (i==1) then
										DUF_Settings[DUF_INDEX][unit][element][i].context = 4;
									else
										DUF_Settings[DUF_INDEX][unit][element][i].context = 5;
									end
									DUF_Settings[DUF_INDEX][unit][element][i].recolor = nil;
								end
							end
							if (i == 1 or i == 4) then
								DUF_Settings[DUF_INDEX][unit][element][i].context = 4;
							elseif (i == 2 or i == 5) then
								DUF_Settings[DUF_INDEX][unit][element][i].context = 5;
								DUF_Settings[DUF_INDEX][unit][element][i].hideifnomana = true;
							end
						end
					else
						DUF_Settings[DUF_INDEX][unit][element].backgroundstyle = 2;
						DUF_Settings[DUF_INDEX][unit][element].bgalpha = 1;
						DUF_Settings[DUF_INDEX][unit][element].bgcolor.a = nil;
						DUF_Settings[DUF_INDEX][unit][element].bgpadding = 5;
						DUF_Settings[DUF_INDEX][unit][element].context = nil;
						if (not DUF_Settings[DUF_INDEX][unit][element].mouseovercolor) then
							DUF_Settings[DUF_INDEX][unit][element].mouseovercolor = {r=1, g=1, b=0};
						end
						DUF_Settings[DUF_INDEX][unit][element].attach = "Unit Frame";
						DUF_Settings[DUF_INDEX][unit][element].attachpoint = "TOPLEFT";
						DUF_Settings[DUF_INDEX][unit][element].attachto = "TOPLEFT";
						DUF_Settings[DUF_INDEX][unit][element].leftclick = 1;
						DUF_Settings[DUF_INDEX][unit][element].rightclick = 3;
						DUF_Settings[DUF_INDEX][unit][element].middleclick = 2;
						if (not DUF_Settings[DUF_INDEX][unit][element].borderalpha) then
							DUF_Settings[DUF_INDEX][unit][element].borderalpha = 1;
						end
					end
				end
			end
		end
		DUF_Settings[DUF_INDEX].target.ComboPoints.backgroundstyle = 2;
		DUF_Settings[DUF_INDEX].target.ComboPoints.bgalpha = 1;
		DUF_Settings[DUF_INDEX].target.ComboPoints.bgcolor.a = nil;
		DUF_Settings[DUF_INDEX].target.ComboPoints.bgpadding = 5;
		DUF_Settings[DUF_INDEX].target.ComboPoints.attach = "Unit Frame";
		DUF_Settings[DUF_INDEX].target.ComboPoints.attachpoint = "TOPLEFT";
		DUF_Settings[DUF_INDEX].target.ComboPoints.attachto = "TOPLEFT";
		DUF_Settings[DUF_INDEX].target.ComboPoints.mouseovercolor = { r=1, g=1, b=0 };
		DUF_Settings[DUF_INDEX].target.EliteTexture = { size=128, alpha=1, bgcolor={0,0,0}, bordercolor={0,0,0}, mouseovercolor={1,1,0}, bgalpha=1, bgpadding=5, hidebg=true, backgroundstyle=2, borderalpha=1, xoffset=0, yoffset=0, attach="Unit Frame", attachto="TOPLEFT", attachpoint="TOPLEFT", hide=true};
	end
	DUF_Settings[DUF_INDEX].ComboOffset = nil;

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.0f"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				for i=1,10 do
					if (tonumber(DUF_Settings[DUF_INDEX][unit].TextBox[i].font)) then
						DUF_Settings[DUF_INDEX][unit].TextBox[i].font = "DUF_Font"..DUF_Settings[DUF_INDEX][unit].TextBox[i].font..".ttf";
					end
				end
			end
		end
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.1"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				DUF_Settings[DUF_INDEX][unit].Portrait.bordcolor = { r=1, g=1, b=1 };
				for _,element in pairs(DUF_ELEMENT_INDICES) do
					if (element == "TextBox") then
						for i=1,10 do
							DUF_Settings[DUF_INDEX][unit][element][i].framelevel = 0;
							DUF_Settings[DUF_INDEX][unit][element][i].framestrata = "LOW";
							DUF_Settings[DUF_INDEX][unit][element][i].label = DUF_TEXT["TextBox"..i];
						end
					elseif (element == "StatusBar") then
						for i=1,6 do
							if (DUF_Settings[DUF_INDEX][unit][element][i]) then
								DUF_Settings[DUF_INDEX][unit][element][i].framelevel = 0;
								DUF_Settings[DUF_INDEX][unit][element][i].framestrata = "BACKGROUND";
							end
						end
					else
						if (DUF_Settings[DUF_INDEX][unit][element] == nil) then
							DUF_Settings[DUF_INDEX][unit][element] = { }
						end;
						DUF_Settings[DUF_INDEX][unit][element].framelevel = 0;
						DUF_Settings[DUF_INDEX][unit][element].framestrata = "LOW";
					end
				end
			end
		end
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.2"]) then
		DUF_Settings[DUF_INDEX].player.Buffs.durationheight = 6;
		DUF_Settings[DUF_INDEX].player.Buffs.durationcolor = {r=1, g=1, b=1};
		DUF_Settings[DUF_INDEX].player.Buffs.durationfont = "DUF_Font1.ttf";
		DUF_Settings[DUF_INDEX].player.Buffs.durationalpha = 1;
		DUF_Settings[DUF_INDEX].player.Buffs.durationx = 0;
		DUF_Settings[DUF_INDEX].player.Buffs.durationy = -5;
		DUF_Settings[DUF_INDEX].player.Debuffs.durationheight = 6;
		DUF_Settings[DUF_INDEX].player.Debuffs.durationcolor = {r=1, g=1, b=1};
		DUF_Settings[DUF_INDEX].player.Debuffs.durationfont = "DUF_Font1.ttf";
		DUF_Settings[DUF_INDEX].player.Debuffs.durationalpha = 1;
		DUF_Settings[DUF_INDEX].player.Debuffs.durationx = 0;
		DUF_Settings[DUF_INDEX].player.Debuffs.durationy = -5;
		for i=0,3 do
			DUF_Settings[DUF_INDEX]["usefor"..i] = 1;
		end
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.2c"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				DUF_Settings[DUF_INDEX][unit].Buffs.hspacing = DUF_Settings[DUF_INDEX][unit].Buffs.spacing;
				DUF_Settings[DUF_INDEX][unit].Buffs.vspacing = DUF_Settings[DUF_INDEX][unit].Buffs.spacing;
				DUF_Settings[DUF_INDEX][unit].Debuffs.hspacing = DUF_Settings[DUF_INDEX][unit].Debuffs.spacing;
				DUF_Settings[DUF_INDEX][unit].Debuffs.vspacing = DUF_Settings[DUF_INDEX][unit].Debuffs.spacing;
			end
		end
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.3s"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				for i=1,6 do
					if (DUF_Settings[DUF_INDEX][unit].StatusBar[i]) then
						DUF_Settings[DUF_INDEX][unit].StatusBar[i].direction = 1;
					end
				end
			end
		end
	end
	--Eris
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.3t"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				for _,element in pairs(DUF_ELEMENT_INDICES) do
					if (element == "StatusBar") then
						DUF_Settings[DUF_INDEX][unit].StatusBar[7] = {};
						DL_Copy_Table(DUF_Settings[DUF_INDEX].player.StatusBar[2], DUF_Settings[DUF_INDEX][unit].StatusBar[7]);
						DUF_Settings[DUF_INDEX][unit].StatusBar[7].hide = true;
						DUF_Settings[DUF_INDEX][unit].StatusBar[7].hideifnocast = false;
						DUF_Settings[DUF_INDEX][unit].StatusBar[7].direction = 1;
					end
				end
			end
		end
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.3x"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				for _,element in pairs(DUF_ELEMENT_INDICES) do
					if (element == "Buffs" or element == "Debuffs") then
						DUF_Settings[DUF_INDEX][unit][element].showduration = 1;
						DUF_Settings[DUF_INDEX][unit][element].altformat = 1;
						DUF_Settings[DUF_INDEX][unit][element].durationx = 0;
						DUF_Settings[DUF_INDEX][unit][element].durationy = -5;
						DUF_Settings[DUF_INDEX][unit][element].durationheight = 6;
						DUF_Settings[DUF_INDEX][unit][element].durationalpha = 1;
						DUF_Settings[DUF_INDEX][unit][element].durationfont = "DUF_Font1.ttf";
						DUF_Settings[DUF_INDEX][unit][element].durationcolor = {r=1, g=1, b=1};
					end
				end
			end
		end
		DUF_Settings[DUF_INDEX]["classcolorShaman"] = {
				["r"] = .14,
				["g"] = .35,
				["b"] = 1,
			};
	end
	
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.4"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do			
			if unit ~= "boss" then
				DUF_Settings[DUF_INDEX][unit].VoiceIcon = {
					["bgcolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["borderalpha"] = 0,
					["framestrata"] = "LOW",
					["attachpoint"] = "TOPLEFT",
					["framelevel"] = 0,
					["middleclick"] = 2,
					["attachto"] = "TOPLEFT",
					["mouseovercolor"] = {
						["b"] = 0,
						["g"] = 1,
						["r"] = 1,
					},
					["size"] = 20,
					["bgpadding"] = 5,
					["attach"] = "Unit Frame",
					["bordercolor"] = {
						["r"] = 0,
						["g"] = 0,
						["b"] = 0,
					},
					["alpha"] = 1,
					["yoffset"] = 0,
					["hide"] = false,
					["backgroundstyle"] = 2,
					["xoffset"] = 0,
					["bgalpha"] = 1,
					["rightclick"] = 3,
					["leftclick"] = 1,
					["bgtexture"] = "VoiceChat-Speaker.tga",
				};
			end
		end
	end;

-- scree, 3.0.3a, Dec 2008
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED3.0.3a"]) then
		DUF_Settings[DUF_INDEX]["classcolorDeathKnight"] = {
				["r"] = 0.77,
				["g"] = 0.12,
				["b"] = 0.23,
			};
	end
	
-- scree, 3.1.0a, Mar 2009
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED3.1.0a"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				local statusBarHasMana = { 2, 5 };
				for _,v in ipairs(statusBarHasMana) do
					if unit ~= "boss" then
						DUF_Settings[DUF_INDEX][unit].StatusBar[v]["runicpowercolor"] = {
							["r"] = 0.00,
							["g"] = 0.82,
							["b"] = 1.00,
						};
					end
				end
			end
		end
	end

--Fizzlemizz: Comment: 4.0 initalisation settings for TempEnchants
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED4.0"]) then
		DUF_Settings[DUF_INDEX]["player"].TempEnchants = {
				["bgcolor"] = {
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["borderalpha"] = 1,
				["rightclick"] = 3,
				["altformat"] = 1,
				["bgalpha"] = 1,
				["framelevel"] = 0,
				["middleclick"] = 2,
				["vertical"] = false,
				["spacing"] = 3,
				["mouseovercolor"] = {
					["b"] = 0,
					["g"] = 1,
					["r"] = 1,
				},
				["vspacing"] = 0,
				["hspacing"] = -10,
				["hidebg"] = 1,
				["shown"] = 2,
				["bgpadding"] = 5,
				["background"] = false,
				["framestrata"] = "LOW",
				["leftclick"] = 1,
				["attach"] = "Unit Frame",
				["bordercolor"] = {
					["r"] = 1,
					["g"] = 1,
					["b"] = 1,
				},
				["mouseover"] = false,
				["attachto"] = "TOPRIGHT",
				["attachpoint"] = "TOPRIGHT",
				["backgroundstyle"] = 2,
				["alpha"] = 1,
				["xoffset"] = -167,
				["size"] = 32,
				["yoffset"] = 27,
				["durationheight"] = 6,
				["durationheight"] = 6;
				["durationcolor"] = {
					["r"] = 1,
					["g"] = 1,
					["b"] = 1,
				};
				["durationfont"] = "DUF_Font1.ttf";
				["durationalpha"] = 1;
				["durationx"] = 0;
				["durationy"] = -5;
			};
	end

--Fizzlemizz: Comment: 4.0a initalisation settings for Druid Mana Bar
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED4.0a"]) then
		DUF_Settings[DUF_INDEX]["player"]["StatusBar"][8] = {
					["direction"] = 3,
					["bgcolor"] = {
						["b"] = 0,
						["g"] = 0,
						["r"] = 0,
					},
					["borderalpha"] = 0.5,
					["rightclick"] = 3,
					["attachpoint"] = "BOTTOMLEFT",
					["middleclick"] = 2,
					["runicpowercolor"] = {
						["r"] = 0,
						["g"] = 0.82,
						["b"] = 1,
					},
					["recolor"] = false,
					["bordercolor"] = {
						["b"] = 0,
						["g"] = 0,
						["r"] = 0,
					},
					["color2"] = {
						["b"] = 0.8901960784313725,
						["g"] = 0.04705882352941176,
						["r"] = 0.7215686274509804,
					},
					["height"] = 40,
					["yoffset"] = 0,
					["framelevel"] = 0,
					["attachto"] = "BOTTOMRIGHT",
					["mouseovercolor"] = {
						["b"] = 0,
						["g"] = 1,
						["r"] = 1,
					},
					["framestrata"] = "BACKGROUND",
					["focuscolor"] = {
						["b"] = 0.9215686274509803,
						["g"] = 0.5568627450980392,
						["r"] = 0.5568627450980392,
					},
					["alpha"] = 1,
					["customtexture2"] = "bg",
					["manacolor"] = {
						["b"] = 0.9215686274509803,
						["g"] = 0.5568627450980392,
						["r"] = 0.5568627450980392,
					},
					["bordersize"] = 1,
					["attach"] = "_ManaBar",
					["width"] = 10,
					["backgroundstyle"] = 1,
					["bgpadding"] = 1,
					["xoffset"] = 0,
					["fade"] = 1,
					["hideifnomana"] = 1,
					["bgalpha"] = 0,
					["customtexture"] = "bg",
					["leftclick"] = 1,
				}; -- [8] Druid Mana Bar
	end
--Fizzlemizz: Comment: 4.1a initalisation settings for duration timer performance update
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED4.0b"]) then
		DUF_Settings[DUF_INDEX].limitdurationupdates = nil
	end

--Fizzlemizz: Comment: 4.15 initalisation settings for Temp. Enchant MouseOver error
	if (DUF_Settings[DUF_INDEX]["player"].TempEnchants.usemouseovercolor == nil) then
		DUF_Settings[DUF_INDEX]["player"]["TempEnchants"].usemouseovercolor = 0;
	end
	
--Fizzlemizz: Comment: 4.17 Setting for 3D models
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED4.17"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				DUF_Settings[DUF_INDEX][unit]["Portrait"].use3D = false;
				DUF_Settings[DUF_INDEX][unit]["Portrait"].use3Dface = false;
			end
		end
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED4.18"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			if unit ~= "boss" then
				DUF_Settings[DUF_INDEX][unit]["RoleIcon"] = {
					["bgcolor"] = {
						["r"] = 0,
						["g"] = 0,
						["b"] = 0,
					},
					["borderalpha"] = 1,
					["rightclick"] = 3,
					["attachpoint"] = "CENTER",
					["middleclick"] = 2,
					["attachto"] = "BOTTOMRIGHT",
					["mouseovercolor"] = {
						["b"] = 0,
						["g"] = 1,
						["r"] = 1,
					},
					["hide"] = 1,
					["bgpadding"] = 3,
					["attach"] = "_Portrait",
					["bordercolor"] = {
						["r"] = 0.996078,
						["g"] = 1,
						["b"] = 0,
					},
					["alpha"] = 1,
					["leftclick"] = 1,
					["size"] = 25,
					["backgroundstyle"] = 2,
					["xoffset"] = 4,
					["bgalpha"] = 1,
					["hidebg"] = 1,
					["yoffset"] = -4,
				};
			end
		end
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.0"]) then
		DUF_Settings[DUF_INDEX]["classcolorMonk"] = {
			["r"] = 0,
			["g"] = 1,
			["b"] = .588,
		};
	end	

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.0a"]) then
		DUF_Settings[DUF_INDEX].player["MonkHarmony"] = {
			["bgcolor"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["borderalpha"] = 0,
			["customtexture"] = "",
			["bgalpha"] = 1,
			["framelevel"] = 0,
			["spacing"] = 0,
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["size"] = 13,
			["bgpadding"] = 5,
			["attach"] = "Unit Frame",
			["bordercolor"] = {
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["alpha"] = 1,
			["hidebg"] = 1,
			["attachto"] = "TOP",
			["color"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["disablemouse"] = 1,
			["attachpoint"] = "BOTTOM",
			["xoffset"] = 0,
			["framestrata"] = "BACKGROUND",
			["backgroundstyle"] = 2,
			["yoffset"] = 5,
		};
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.0b"]) then
		DUF_Settings[DUF_INDEX].player.MonkHarmony["bgsize"] = {
				["width"] = 12,
				["height"] = 16,
			};

		DUF_Settings[DUF_INDEX].player["PalyPowerFrame"] = {
			["bgcolor"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["borderalpha"] = 0,
			["customtexture"] = "",
			["bgalpha"] = 1,
			["framelevel"] = 0,
			["spacing"] = 0,
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["bgsize"] = {
				["width"] = 12,
				["height"] = 16,
			},
			["size"] = 20,
			["bgpadding"] = 5,
			["hidebg"] = 1,
			["attach"] = "Unit Frame",
			["bordercolor"] = {
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["alpha"] = 1,
			["backgroundstyle"] = 2,
			["attachto"] = "TOP",
			["color"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["attachpoint"] = "BOTTOM",
			["xoffset"] = 0,
			["disablemouse"] = 1,
			["framestrata"] = "BACKGROUND",
			["yoffset"] = 10,
		};
		DUF_Settings[DUF_INDEX].player["WarlockPowerFrame"] = {
			["bgcolor"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["borderalpha"] = 0,
			["customtexture"] = "",
			["bgalpha"] = 1,
			["framelevel"] = 0,
			["spacing"] = 0,
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["bgsize"] = {
				["width"] = 12,
				["height"] = 16,
			},
			["size"] = 13,
			["bgpadding"] = 5,
			["hidebg"] = 1,
			["attach"] = "Unit Frame",
			["bordercolor"] = {
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["alpha"] = 1,
			["backgroundstyle"] = 2,
			["attachto"] = "TOP",
			["color"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["attachpoint"] = "BOTTOM",
			["xoffset"] = 0,
			["disablemouse"] = 1,
			["framestrata"] = "BACKGROUND",
			["yoffset"] = 17,
		};
		DUF_Settings[DUF_INDEX].player["RuneFrame"] = {
			["bgcolor"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["bgsize"] = {
				["width"] = 12,
				["height"] = 16,
			},
			["bgHeight"] = 16,
			["borderalpha"] = 0,
			["customtexture"] = "",
			["bgalpha"] = 1,
			["hidebg"] = 1,
			["framelevel"] = 0,
			["spacing"] = 10,
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["size"] = 13,
			["bgpadding"] = 5,
			["attach"] = "Unit Frame",
			["bordercolor"] = {
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["alpha"] = 1,
			["backgroundstyle"] = 2,
			["attachto"] = "TOP",
			["color"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["attachpoint"] = "BOTTOM",
			["xoffset"] = -51,
			["disablemouse"] = 1,
			["framestrata"] = "BACKGROUND",
			["yoffset"] = 5,
		};
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.0c"]) then
		DUF_Settings[DUF_INDEX].player.WarlockPowerFrame.DemoBar = nil;

		DUF_Settings[DUF_INDEX]["player"]["StatusBar"][9] = {
			["direction"] = 1,
			["bgcolor"] = {
				["b"] = 0.0117647,
				["g"] = 0,
				["r"] = 0.294118,
			},
			["borderalpha"] = 1,
			["rightclick"] = 3,
			["bgalpha"] = 1,
			["fade"] = 1,
			["middleclick"] = 2,
			["attachto"] = "TOPLEFT",
			["mouseovercolor"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 0,
			},
			["context"] = 4,
			["hide"] = false,
			["bgpadding"] = 1,
			["framestrata"] = "BACKGROUND",
			["framelevel"] = 0,
			["attach"] = "Unit Frame",
			["bordercolor"] = {
				["r"] = 0.694118,
				["g"] = 0.654902,
				["b"] = 0,
			},
			["bordersize"] = 1,
			["width"] = 131,
			["color2"] = {
				["b"] = 1,
				["g"] = 0.7333333333333333,
				["r"] = 0.8980392156862745,
			},
			["yoffset"] = 16,
			["alpha"] = 1,
			["xoffset"] = 59,
			["height"] = 11,
			["attachpoint"] = "TOPLEFT",
			["color"] = {
				["b"] = 1,
				["g"] = 0.2980392156862745,
				["r"] = 0.7764705882352941,
			},
			["leftclick"] = 1,
		}; -- [9] Warlock Demonic Power Bar


		DUF_Settings[DUF_INDEX]["player"]["TextBox"][11] = {
			["outline"] = "NORMAL",
			["leftclick"] = 1,
			["bgcolor"] = {
				["b"] = 0.09019607843137255,
				["g"] = 0.01176470588235294,
				["r"] = 0.08627450980392157,
			},
			["borderalpha"] = 0,
			["framestrata"] = "LOW",
			["attachpoint"] = "LEFT",
			["justifyV"] = "TOP",
			["verttext"] = 1,
			["textheight"] = 9,
			["middleclick"] = 2,
			["bgalpha"] = 0.57,
			["bgcolorcontext"] = "No Context",
			["attachto"] = "RIGHT",
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["height"] = 50,
			["colorcontext"] = "No Context",
			["hidebg"] = 1,
			["bgpadding"] = 7,
			["textcolor"] = {
				["r"] = 0.984313725490196,
				["g"] = 0.996078431372549,
				["b"] = 1,
			},
			["justify"] = "LEFT",
			["alpha"] = 1,
			["attach"] = "_HealthBar",
			["text"] = "$rp%",
			["backgroundstyle"] = 2,
			["width"] = 14,
			["rightclick"] = 3,
			["font"] = "DUF_Font3.ttf",
			["bordercolor"] = {
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["bgtexture"] = "",
			["xoffset"] = 0,
			["framelevel"] = 1,
			["yoffset"] = 0,
		}; -- [11] Druid mana Bar Text

		DUF_Settings[DUF_INDEX]["player"]["TextBox"][12] = {
			["outline"] = "NORMAL",
			["leftclick"] = 1,
			["bgcolor"] = {
				["b"] = 0.09019607843137255,
				["g"] = 0.01176470588235294,
				["r"] = 0.08627450980392157,
			},
			["borderalpha"] = 0,
			["framestrata"] = "LOW",
			["attachpoint"] = "RIGHT",
			["justifyV"] = "CENTER",
			["textheight"] = 7,
			["middleclick"] = 2,
			["bgalpha"] = 0.57,
			["bgcolorcontext"] = "No Context",
			["attachto"] = "RIGHT",
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["height"] = 10,
			["colorcontext"] = "No Context",
			["hidebg"] = 1,
			["bgpadding"] = 7,
			["textcolor"] = {
				["r"] = 0.984313725490196,
				["g"] = 0.996078431372549,
				["b"] = 1,
			},
			["justify"] = "LEFT",
			["alpha"] = 1,
			["attach"] = "_DemonicPowerBar",
			["text"] = "$dc/$dm",
			["backgroundstyle"] = 2,
			["width"] = 108,
			["rightclick"] = 3,
			["font"] = "DUF_Font3.ttf",
			["bordercolor"] = {
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["bgtexture"] = "",
			["xoffset"] = 0,
			["framelevel"] = 1,
			["yoffset"] = 0,
		}; -- [12] Warlock Fury Bar Text
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.1"]) then
		DUF_Settings[DUF_INDEX].player["PriestOrbFrame"] = {
			["bgcolor"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["bgsize"] = {
				["width"] = 12,
				["height"] = 16,
			},
			["borderalpha"] = 0,
			["customtexture"] = "",
			["bgalpha"] = 1,
			["framelevel"] = 0,
			["spacing"] = 0,
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["size"] = 13,
			["bgpadding"] = 5,
			["attach"] = "Unit Frame",
			["bordercolor"] = {
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["alpha"] = 1,
			["hidebg"] = 1,
			["attachto"] = "TOP",
			["color"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["disablemouse"] = 1,
			["attachpoint"] = "BOTTOM",
			["xoffset"] = 0,
			["framestrata"] = "BACKGROUND",
			["backgroundstyle"] = 2,
			["yoffset"] = 5,
		};
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.2"]) then
		DUF_Settings[DUF_INDEX]["boss"] = {
			["bgcolor"] = {
				["b"] = 0.0431373,
				["g"] = 0,
				["r"] = 0.611765,
			},
			["borderalpha"] = 1,
			["rightclick"] = 3,
			["EliteTexture"] = {
				["bgcolor"] = {
					[1] = 0,
					[2] = 0,
					[3] = 0,
				},
				["borderalpha"] = 1,
				["faceleft"] = 1,
				["attachto"] = "TOP",
				["mouseovercolor"] = {
					[1] = 1,
					[2] = 1,
					[3] = 0,
				},
				["hidebg"] = true,
				["bgpadding"] = 5,
				["attach"] = "_Portrait",
				["bordercolor"] = {
					[1] = 0,
					[2] = 0,
					[3] = 0,
				},
				["backgroundstyle"] = 2,
				["attachpoint"] = "TOP",
				["bgalpha"] = 1,
				["xoffset"] = 10,
				["alpha"] = 1,
				["size"] = 84,
				["yoffset"] = 19,
			},
			["PVPIcon"] = {
				["bgcolor"] = {
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["borderalpha"] = 1,
				["rightclick"] = 3,
				["bgalpha"] = 1,
				["framelevel"] = 0,
				["middleclick"] = 2,
				["attachto"] = "BOTTOMRIGHT",
				["mouseovercolor"] = {
					["r"] = 1,
					["g"] = 1,
					["b"] = 0,
				},
				["hide"] = false,
				["bgpadding"] = 3,
				["attach"] = "_Portrait",
				["bordercolor"] = {
					["b"] = 0,
					["g"] = 1,
					["r"] = 0.996078,
				},
				["alpha"] = 1,
				["yoffset"] = -4,
				["hidebg"] = 1,
				["attachpoint"] = "CENTER",
				["backgroundstyle"] = 2,
				["xoffset"] = 4,
				["size"] = 25,
				["framestrata"] = "LOW",
				["leftclick"] = 1,
			},
			["yos"] = {
				-135.501, -- [1]
				-217.5, -- [2]
				-369, -- [3]
				-274.5, -- [4]
				-424.5, -- [5]
			},
			["xos"] = {
				1230.5, -- [1]
				147.75, -- [2]
				154.5, -- [3]
				131.25, -- [4]
				177.25, -- [5]
			},
			["middleclick"] = 2,
			["usemouseovercolor"] = 1,
			["colorcontext"] = "No Context",
			["bgpadding"] = 5,
			["StatusIcon"] = {
				["bgcolor"] = {
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["borderalpha"] = 1,
				["rightclick"] = 3,
				["bgalpha"] = 1,
				["framelevel"] = 0,
				["middleclick"] = 2,
				["attachto"] = "TOPRIGHT",
				["mouseovercolor"] = {
					["r"] = 1,
					["g"] = 1,
					["b"] = 0,
				},
				["hide"] = false,
				["bgpadding"] = 5,
				["attach"] = "_Portrait",
				["bordercolor"] = {
					["b"] = 0.00784314,
					["g"] = 1,
					["r"] = 0.972549,
				},
				["alpha"] = 1,
				["yoffset"] = 2,
				["hidebg"] = 1,
				["attachpoint"] = "CENTER",
				["backgroundstyle"] = 2,
				["xoffset"] = 5,
				["size"] = 25,
				["framestrata"] = "LOW",
				["leftclick"] = 1,
			},
			["bordercolor"] = {
				["r"] = 1,
				["g"] = 0.992157,
				["b"] = 0.0156863,
			},
			["height"] = 39,
			["ClassIcon"] = {
				["bgcolor"] = {
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["borderalpha"] = 0,
				["rightclick"] = 3,
				["attachpoint"] = "TOPLEFT",
				["framelevel"] = 0,
				["middleclick"] = 2,
				["attachto"] = "TOPLEFT",
				["mouseovercolor"] = {
					["r"] = 1,
					["g"] = 1,
					["b"] = 0,
				},
				["size"] = 20,
				["bgpadding"] = 5,
				["attach"] = "Unit Frame",
				["bordercolor"] = {
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["alpha"] = 1,
				["yoffset"] = -5,
				["hide"] = true,
				["backgroundstyle"] = 2,
				["xoffset"] = 109,
				["bgalpha"] = 1,
				["framestrata"] = "LOW",
				["leftclick"] = 1,
			},
			["Debuffs"] = {
				["durationy"] = -5,
				["bgcolor"] = {
					["r"] = 0.0196078,
					["g"] = 0.247059,
					["b"] = 0.0196078,
				},
				["borderalpha"] = 1,
				["shown"] = 8,
				["attachpoint"] = "LEFT",
				["middleclick"] = 2,
				["tworows"] = 1,
				["background"] = false,
				["size"] = 13,
				["bgpadding"] = 5,
				["durationx"] = 0,
				["bordercolor"] = {
					["r"] = 1,
					["g"] = 0.0156863,
					["b"] = 0,
				},
				["mouseover"] = false,
				["durationalpha"] = 1,
				["xoffset"] = 8,
				["yoffset"] = 0,
				["showduration"] = 1,
				["framelevel"] = 0,
				["vertical"] = false,
				["attachto"] = "RIGHT",
				["mouseovercolor"] = {
					["r"] = 1,
					["g"] = 1,
					["b"] = 0,
				},
				["vspacing"] = 0,
				["durationcolor"] = {
					["r"] = 1,
					["g"] = 1,
					["b"] = 1,
				},
				["framestrata"] = "LOW",
				["attach"] = "_Buffs",
				["alpha"] = 1,
				["backgroundstyle"] = 2,
				["durationheight"] = 6,
				["durationfont"] = "DUF_Font1.ttf",
				["hspacing"] = 0,
				["altformat"] = 1,
				["spacing"] = 0,
				["flash"] = 1,
				["rightclick"] = 3,
				["bgalpha"] = 1,
				["leftclick"] = 1,
			},
			["RaceIcon"] = {
				["bgcolor"] = {
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["borderalpha"] = 0,
				["rightclick"] = 3,
				["attachpoint"] = "TOPLEFT",
				["framelevel"] = 0,
				["middleclick"] = 2,
				["attachto"] = "TOPLEFT",
				["mouseovercolor"] = {
					["b"] = 0,
					["g"] = 1,
					["r"] = 1,
				},
				["size"] = 20,
				["bgpadding"] = 5,
				["attach"] = "Unit Frame",
				["bordercolor"] = {
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["alpha"] = 1,
				["leftclick"] = 1,
				["bgalpha"] = 1,
				["backgroundstyle"] = 2,
				["xoffset"] = 109,
				["hide"] = true,
				["framestrata"] = "LOW",
				["yoffset"] = -5,
			},
			["TextBox"] = {
				{
					["yoffset"] = 2,
					["bordercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["bgcolor"] = {
						["r"] = 0,
						["g"] = 0,
						["b"] = 0,
					},
					["label"] = "TextBox 1",
					["framestrata"] = "LOW",
					["attachpoint"] = "TOPLEFT",
					["justifyV"] = "TOP",
					["textheight"] = 9.5,
					["middleclick"] = 2,
					["backgroundstyle"] = 1,
					["xoffset"] = 48,
					["attachto"] = "TOPLEFT",
					["mouseovercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 0,
					},
					["bgcolorcontext"] = "No Context",
					["colorcontext"] = "No Context",
					["hidebg"] = 1,
					["bgpadding"] = 0,
					["textcolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["justify"] = "CENTER",
					["alpha"] = 1,
					["attach"] = "Unit Frame",
					["text"] = "$nm$nlLvl $lv $cl",
					["mouseover"] = false,
					["width"] = 100,
					["borderalpha"] = 0,
					["font"] = "DUF_Font1.ttf",
					["mouseovergroup"] = 1,
					["bgalpha"] = 1,
					["height"] = 24,
					["framelevel"] = 0,
					["rightclick"] = 3,
					["leftclick"] = 1,
				}, -- [1]
				{
					["bgcolor"] = {
						["r"] = 0,
						["g"] = 0,
						["b"] = 0,
					},
					["borderalpha"] = 0,
					["rightclick"] = 3,
					["attachpoint"] = "LEFT",
					["textheight"] = 8.75,
					["middleclick"] = 2,
					["colorcontext"] = "No Context",
					["bgpadding"] = 0,
					["bordercolor"] = {
						["b"] = 0,
						["g"] = 0.729412,
						["r"] = 0.721569,
					},
					["mouseover"] = false,
					["font"] = "DUF_Font1.ttf",
					["xoffset"] = 1,
					["yoffset"] = 0,
					["label"] = "TextBox 2",
					["justifyV"] = "CENTER",
					["framelevel"] = 0,
					["attachto"] = "RIGHT",
					["mouseovercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 0,
					},
					["hide"] = false,
					["textcolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["justify"] = "CENTER",
					["attach"] = "_HealthBar",
					["framestrata"] = "LOW",
					["backgroundstyle"] = 1,
					["width"] = 56,
					["alpha"] = 1,
					["text"] = "$hc/$hm",
					["mouseovergroup"] = 1,
					["height"] = 11,
					["hidebg"] = 1,
					["bgcolorcontext"] = "No Context",
					["bgalpha"] = 1,
					["leftclick"] = 1,
				}, -- [2]
				{
					["bgcolor"] = {
						["r"] = 0,
						["g"] = 0,
						["b"] = 0,
					},
					["borderalpha"] = 0,
					["rightclick"] = 3,
					["attachpoint"] = "LEFT",
					["textheight"] = 7.5,
					["middleclick"] = 2,
					["colorcontext"] = "No Context",
					["bgpadding"] = 0,
					["bordercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["mouseover"] = false,
					["font"] = "DUF_Font1.ttf",
					["xoffset"] = 1,
					["yoffset"] = 0,
					["label"] = "TextBox 3",
					["justifyV"] = "CENTER",
					["framelevel"] = 0,
					["attachto"] = "RIGHT",
					["mouseovercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 0,
					},
					["hide"] = false,
					["textcolor"] = {
						["r"] = 0,
						["g"] = 1,
						["b"] = 0.968627,
					},
					["justify"] = "CENTER",
					["attach"] = "_ManaBar",
					["framestrata"] = "LOW",
					["backgroundstyle"] = 1,
					["width"] = 56,
					["alpha"] = 1,
					["text"] = "$mc/$mm",
					["mouseovergroup"] = 1,
					["height"] = 7,
					["hidebg"] = true,
					["bgcolorcontext"] = "No Context",
					["bgalpha"] = 1,
					["leftclick"] = 1,
				}, -- [3]
				{
					["bgcolor"] = {
						["r"] = 0,
						["g"] = 0,
						["b"] = 0,
					},
					["borderalpha"] = 0,
					["rightclick"] = 3,
					["attachpoint"] = "TOPRIGHT",
					["textheight"] = 15.5,
					["middleclick"] = 2,
					["colorcontext"] = "No Context",
					["bgpadding"] = 1,
					["bordercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["mouseover"] = false,
					["font"] = "DUF_Font1.ttf",
					["xoffset"] = 0,
					["yoffset"] = 0,
					["label"] = "TextBox 4",
					["justifyV"] = "TOP",
					["framelevel"] = 0,
					["attachto"] = "TOPRIGHT",
					["mouseovercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 0,
					},
					["hide"] = false,
					["textcolor"] = {
						["b"] = 0.898039,
						["g"] = 1,
						["r"] = 0,
					},
					["justify"] = "RIGHT",
					["attach"] = "Unit Frame",
					["framestrata"] = "LOW",
					["backgroundstyle"] = 1,
					["width"] = 93,
					["alpha"] = 1,
					["text"] = "$rd $rh",
					["mouseovergroup"] = 1,
					["height"] = 14,
					["hidebg"] = 1,
					["bgcolorcontext"] = "No Context",
					["bgalpha"] = 1,
					["leftclick"] = 1,
				}, -- [4]
				{
					["yoffset"] = -4.5,
					["bgalpha"] = 1,
					["bgcolor"] = {
						["r"] = 0.321569,
						["g"] = 0.172549,
						["b"] = 0.462745,
					},
					["label"] = "TextBox 5",
					["framestrata"] = "LOW",
					["attachpoint"] = "TOP",
					["justifyV"] = "CENTER",
					["textheight"] = 7.5,
					["middleclick"] = 2,
					["text"] = "",
					["xoffset"] = 0,
					["attachto"] = "BOTTOM",
					["mouseovercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 0,
					},
					["bordercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["colorcontext"] = "No Context",
					["hidebg"] = 1,
					["bgpadding"] = 1,
					["textcolor"] = {
						["b"] = 0.937255,
						["g"] = 1,
						["r"] = 0.960784,
					},
					["justify"] = "CENTER",
					["alpha"] = 1,
					["attach"] = "Unit Frame",
					["bgcolorcontext"] = "No Context",
					["backgroundstyle"] = 1,
					["width"] = 242,
					["borderalpha"] = 0,
					["font"] = "DUF_Font1.ttf",
					["mouseovergroup"] = 1,
					["hide"] = 1,
					["height"] = 7,
					["framelevel"] = 0,
					["rightclick"] = 3,
					["leftclick"] = 1,
				}, -- [5]
				{
					["yoffset"] = 0,
					["bordercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["bgcolor"] = {
						["r"] = 0,
						["g"] = 0,
						["b"] = 0,
					},
					["label"] = "TextBox 6",
					["framestrata"] = "LOW",
					["attachpoint"] = "CENTER",
					["justifyV"] = "TOP",
					["textheight"] = 16.25,
					["middleclick"] = 2,
					["backgroundstyle"] = 1,
					["xoffset"] = 0,
					["attachto"] = "CENTER",
					["mouseovercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 0,
					},
					["bgcolorcontext"] = "No Context",
					["colorcontext"] = "No Context",
					["hidebg"] = true,
					["bgpadding"] = 1,
					["textcolor"] = {
						["b"] = 0,
						["g"] = 0.027451,
						["r"] = 1,
					},
					["justify"] = "CENTER",
					["alpha"] = 1,
					["attach"] = "_HealthBar",
					["text"] = "$ds $coFFFFFF00$of",
					["mouseover"] = false,
					["width"] = 131,
					["borderalpha"] = 0,
					["font"] = "DUF_Font1.ttf",
					["mouseovergroup"] = 1,
					["bgalpha"] = 1,
					["height"] = 11,
					["framelevel"] = 0,
					["rightclick"] = 3,
					["leftclick"] = 1,
				}, -- [6]
				{
					["yoffset"] = -40,
					["bordercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["bgcolor"] = {
						["r"] = 0,
						["g"] = 0,
						["b"] = 0,
					},
					["label"] = "TextBox 7",
					["framestrata"] = "LOW",
					["bgalpha"] = 1,
					["justifyV"] = "CENTER",
					["textheight"] = 9.75,
					["middleclick"] = 2,
					["hide"] = true,
					["xoffset"] = 150,
					["attachto"] = "TOPLEFT",
					["mouseovercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 0,
					},
					["bgcolorcontext"] = "No Context",
					["colorcontext"] = "No Context",
					["hidebg"] = true,
					["bgpadding"] = 1,
					["textcolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["justify"] = "CENTER",
					["backgroundstyle"] = 1,
					["attach"] = "Unit Frame",
					["text"] = "",
					["mouseover"] = false,
					["width"] = 120,
					["borderalpha"] = 0,
					["font"] = "DUF_Font1.ttf",
					["alpha"] = 1,
					["attachpoint"] = "TOPLEFT",
					["height"] = 26,
					["framelevel"] = 0,
					["rightclick"] = 3,
					["leftclick"] = 1,
				}, -- [7]
				{
					["yoffset"] = -107.75,
					["bordercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["bgcolor"] = {
						["r"] = 0,
						["g"] = 0,
						["b"] = 0,
					},
					["label"] = "TextBox 8",
					["framestrata"] = "LOW",
					["bgalpha"] = 1,
					["justifyV"] = "CENTER",
					["textheight"] = 9.25,
					["middleclick"] = 2,
					["mouseover"] = false,
					["xoffset"] = 39,
					["attachto"] = "TOPLEFT",
					["mouseovercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 0,
					},
					["bgcolorcontext"] = "No Context",
					["colorcontext"] = "No Context",
					["hide"] = 1,
					["bgpadding"] = 1,
					["textcolor"] = {
						["b"] = 0.984314,
						["g"] = 0.996078,
						["r"] = 0,
					},
					["justify"] = "CENTER",
					["backgroundstyle"] = 1,
					["attach"] = "Unit Frame",
					["text"] = "",
					["alpha"] = 1,
					["width"] = 290,
					["borderalpha"] = 0,
					["font"] = "DUF_Font1.ttf",
					["hidebg"] = true,
					["attachpoint"] = "TOPLEFT",
					["height"] = 7,
					["framelevel"] = 0,
					["rightclick"] = 3,
					["leftclick"] = 1,
				}, -- [8]
				{
					["yoffset"] = -138.75,
					["bordercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["bgcolor"] = {
						["r"] = 0,
						["g"] = 0,
						["b"] = 0,
					},
					["label"] = "TextBox 9",
					["framestrata"] = "LOW",
					["bgalpha"] = 1,
					["justifyV"] = "CENTER",
					["textheight"] = 11,
					["middleclick"] = 2,
					["mouseover"] = false,
					["xoffset"] = 300,
					["attachto"] = "TOPLEFT",
					["mouseovercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 0,
					},
					["bgcolorcontext"] = "No Context",
					["colorcontext"] = "No Context",
					["hide"] = 1,
					["bgpadding"] = 1,
					["textcolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["justify"] = "LEFT",
					["backgroundstyle"] = 1,
					["attach"] = "Unit Frame",
					["text"] = "",
					["alpha"] = 1,
					["width"] = 60,
					["borderalpha"] = 0,
					["font"] = "DUF_Font1.ttf",
					["hidebg"] = true,
					["attachpoint"] = "TOPLEFT",
					["height"] = 14,
					["framelevel"] = 0,
					["rightclick"] = 3,
					["leftclick"] = 1,
				}, -- [9]
				{
					["yoffset"] = -91.75,
					["bordercolor"] = {
						["r"] = 0,
						["g"] = 0,
						["b"] = 0,
					},
					["bgcolor"] = {
						["r"] = 0,
						["g"] = 0,
						["b"] = 0,
					},
					["label"] = "TextBox 10",
					["framestrata"] = "LOW",
					["bgalpha"] = 1,
					["justifyV"] = "CENTER",
					["textheight"] = 9.75,
					["middleclick"] = 2,
					["hide"] = true,
					["xoffset"] = -201.75,
					["attachto"] = "TOPLEFT",
					["mouseovercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 0,
					},
					["bgcolorcontext"] = "No Context",
					["colorcontext"] = "No Context",
					["hidebg"] = true,
					["bgpadding"] = 1,
					["textcolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["justify"] = "LEFT",
					["backgroundstyle"] = 1,
					["attach"] = "Unit Frame",
					["text"] = "",
					["mouseover"] = false,
					["width"] = 300,
					["borderalpha"] = 1,
					["font"] = "DUF_Font1.ttf",
					["alpha"] = 1,
					["attachpoint"] = "TOPLEFT",
					["height"] = 50,
					["framelevel"] = 0,
					["rightclick"] = 3,
					["leftclick"] = 1,
				}, -- [10]
			},
			["scale"] = 1,
			["RoleIcon"] = {
				["bgcolor"] = {
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["borderalpha"] = 1,
				["rightclick"] = 3,
				["attachpoint"] = "CENTER",
				["middleclick"] = 2,
				["attachto"] = "BOTTOMRIGHT",
				["mouseovercolor"] = {
					["b"] = 0,
					["g"] = 1,
					["r"] = 1,
				},
				["hide"] = 1,
				["bgpadding"] = 3,
				["attach"] = "_Portrait",
				["bordercolor"] = {
					["r"] = 0.996078,
					["g"] = 1,
					["b"] = 0,
				},
				["alpha"] = 1,
				["leftclick"] = 1,
				["size"] = 25,
				["backgroundstyle"] = 2,
				["xoffset"] = 4,
				["bgalpha"] = 1,
				["hidebg"] = 1,
				["yoffset"] = -4,
			},
			["recolor"] = true,
			["flash"] = true,
			["LeaderIcon"] = {
				["bgcolor"] = {
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["borderalpha"] = 1,
				["rightclick"] = 3,
				["bgalpha"] = 1,
				["framelevel"] = 0,
				["middleclick"] = 2,
				["attachto"] = "TOPLEFT",
				["mouseovercolor"] = {
					["r"] = 1,
					["g"] = 1,
					["b"] = 0,
				},
				["hide"] = false,
				["bgpadding"] = 5,
				["attach"] = "_Portrait",
				["bordercolor"] = {
					["b"] = 0,
					["g"] = 1,
					["r"] = 0.929412,
				},
				["alpha"] = 1,
				["yoffset"] = 3,
				["hidebg"] = 1,
				["attachpoint"] = "CENTER",
				["backgroundstyle"] = 2,
				["xoffset"] = -3,
				["size"] = 20,
				["framestrata"] = "LOW",
				["leftclick"] = 1,
			},
			["showDefault"] = false,
			["spacing"] = 40,
			["mouseovercolor"] = {
				["r"] = 1,
				["g"] = 0.984314,
				["b"] = 0,
			},
			["bgalpha"] = 1,
			["hide"] = false,
			["hidebg"] = false,
			["StatusBar"] = {
				{
					["direction"] = 1,
					["bgcolor"] = {
						["b"] = 0.0117647,
						["g"] = 0,
						["r"] = 0.294118,
					},
					["borderalpha"] = 1,
					["rightclick"] = 3,
					["bgalpha"] = 1,
					["fade"] = 1,
					["middleclick"] = 2,
					["attachto"] = "TOPLEFT",
					["mouseovercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 0,
					},
					["yoffset"] = -19,
					["context"] = 4,
					["hide"] = false,
					["bgpadding"] = 1,
					["bordersize"] = 1,
					["alpha"] = 1,
					["xoffset"] = 47,
					["attach"] = "Unit Frame",
					["bordercolor"] = {
						["r"] = 0.694118,
						["g"] = 0.654902,
						["b"] = 0,
					},
					["backgroundstyle"] = 1,
					["width"] = 100,
					["color2"] = {
						["b"] = 0.462745,
						["g"] = 1,
						["r"] = 0.517647,
					},
					["attachpoint"] = "TOPLEFT",
					["mouseovergroup"] = 1,
					["color"] = {
						["b"] = 0,
						["g"] = 0.8,
						["r"] = 0,
					},
					["height"] = 11,
					["framestrata"] = "BACKGROUND",
					["framelevel"] = 0,
					["leftclick"] = 1,
				}, -- [1]
				{
					["yoffset"] = -1,
					["direction"] = 1,
					["bgcolor"] = {
						["r"] = 0,
						["g"] = 0.0156863,
						["b"] = 0.133333,
					},
					["borderalpha"] = 1,
					["rightclick"] = 3,
					["bgalpha"] = 1,
					["ragecolor"] = {
						["r"] = 1,
						["g"] = 0,
						["b"] = 0,
					},
					["fade"] = 1,
					["middleclick"] = 2,
					["attachto"] = "BOTTOMLEFT",
					["height"] = 5,
					["runicpowercolor"] = {
						["r"] = 0,
						["g"] = 0.82,
						["b"] = 1,
					},
					["mouseovercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 0,
					},
					["focuscolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 0,
					},
					["context"] = 5,
					["hide"] = false,
					["bgpadding"] = 1,
					["backgroundstyle"] = 1,
					["manacolor"] = {
						["r"] = 0,
						["g"] = 0,
						["b"] = 1,
					},
					["width"] = 100,
					["attach"] = "_HealthBar",
					["bordercolor"] = {
						["r"] = 0.784314,
						["g"] = 0.694118,
						["b"] = 0,
					},
					["alpha"] = 1,
					["energycolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 0,
					},
					["color2"] = {
						["b"] = 0.878431,
						["g"] = 1,
						["r"] = 0,
					},
					["bordersize"] = 1,
					["mouseovergroup"] = 1,
					["attachpoint"] = "TOPLEFT",
					["xoffset"] = 0,
					["framestrata"] = "BACKGROUND",
					["framelevel"] = 0,
					["leftclick"] = 1,
				}, -- [2]
				nil, -- [3]
				{
					["direction"] = 1,
					["bgcolor"] = {
						["r"] = 0.294118,
						["g"] = 0,
						["b"] = 0.0117647,
					},
					["borderalpha"] = 1,
					["rightclick"] = 3,
					["bgalpha"] = 1,
					["framelevel"] = 0,
					["middleclick"] = 2,
					["attachto"] = "TOPLEFT",
					["mouseovercolor"] = {
						["b"] = 0,
						["g"] = 1,
						["r"] = 1,
					},
					["context"] = 4,
					["hide"] = true,
					["bgpadding"] = 1,
					["leftclick"] = 1,
					["color"] = {
						["r"] = 0,
						["g"] = 0.8,
						["b"] = 0,
					},
					["attach"] = "Unit Frame",
					["bordercolor"] = {
						["b"] = 0,
						["g"] = 0.654902,
						["r"] = 0.694118,
					},
					["bordersize"] = 1,
					["width"] = 213,
					["color2"] = {
						["b"] = 0,
						["g"] = 1,
						["r"] = 1,
					},
					["attachpoint"] = "TOPLEFT",
					["height"] = 14,
					["alpha"] = 1,
					["xoffset"] = 43.7499,
					["backgroundstyle"] = 1,
					["framestrata"] = "BACKGROUND",
					["yoffset"] = -7.49987,
				}, -- [4]
				{
					["direction"] = 1,
					["bgcolor"] = {
						["b"] = 0.133333,
						["g"] = 0.0156863,
						["r"] = 0,
					},
					["borderalpha"] = 1,
					["ragecolor"] = {
						["b"] = 0,
						["g"] = 0,
						["r"] = 1,
					},
					["bgalpha"] = 1,
					["leftclick"] = 1,
					["hideifnomana"] = true,
					["middleclick"] = 2,
					["attachpoint"] = "TOPLEFT",
					["rightclick"] = 3,
					["runicpowercolor"] = {
						["r"] = 0,
						["g"] = 0.82,
						["b"] = 1,
					},
					["mouseovercolor"] = {
						["b"] = 0,
						["g"] = 1,
						["r"] = 1,
					},
					["xoffset"] = 43.75,
					["context"] = 5,
					["hide"] = true,
					["bgpadding"] = 1,
					["manacolor"] = {
						["b"] = 1,
						["g"] = 0,
						["r"] = 0,
					},
					["focuscolor"] = {
						["b"] = 0,
						["g"] = 1,
						["r"] = 1,
					},
					["backgroundstyle"] = 1,
					["attach"] = "Unit Frame",
					["bordercolor"] = {
						["b"] = 0,
						["g"] = 0.694118,
						["r"] = 0.784314,
					},
					["bordersize"] = 1,
					["width"] = 213,
					["color2"] = {
						["b"] = 0,
						["g"] = 1,
						["r"] = 1,
					},
					["framestrata"] = "BACKGROUND",
					["energycolor"] = {
						["b"] = 0,
						["g"] = 1,
						["r"] = 1,
					},
					["alpha"] = 1,
					["height"] = 14,
					["attachto"] = "TOPLEFT",
					["framelevel"] = 0,
					["yoffset"] = -22.4999,
				}, -- [5]
				[7] = {
					["direction"] = 1,
					["bgcolor"] = {
						["r"] = 0,
						["g"] = 0.0156863,
						["b"] = 0.133333,
					},
					["borderalpha"] = 1,
					["rightclick"] = 3,
					["attachpoint"] = "TOPLEFT",
					["framelevel"] = 0,
					["middleclick"] = 2,
					["yoffset"] = -1,
					["fade"] = 1,
					["attachto"] = "BOTTOMLEFT",
					["mouseovercolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 0,
					},
					["framestrata"] = "BACKGROUND",
					["context"] = 5,
					["hide"] = true,
					["bgpadding"] = 1,
					["height"] = 5,
					["manacolor"] = {
						["r"] = 0,
						["g"] = 0,
						["b"] = 1,
					},
					["energycolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 0,
					},
					["attach"] = "_HealthBar",
					["bordercolor"] = {
						["r"] = 0.784314,
						["g"] = 0.694118,
						["b"] = 0,
					},
					["alpha"] = 1,
					["width"] = 131,
					["color2"] = {
						["b"] = 0.878431,
						["g"] = 1,
						["r"] = 0,
					},
					["bordersize"] = 1,
					["focuscolor"] = {
						["r"] = 1,
						["g"] = 1,
						["b"] = 0,
					},
					["ragecolor"] = {
						["r"] = 1,
						["g"] = 0,
						["b"] = 0,
					},
					["xoffset"] = 0,
					["bgalpha"] = 1,
					["hideifnocast"] = false,
					["leftclick"] = 1,
				},
			},
			["connectmethod"] = 1,
			["alpha"] = 1,
			["Portrait"] = {
				["bgcolor"] = {
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["borderalpha"] = 1,
				["rightclick"] = 3,
				["attachpoint"] = "TOPLEFT",
				["framelevel"] = 0,
				["middleclick"] = 2,
				["attachto"] = "TOPLEFT",
				["mouseovercolor"] = {
					["r"] = 1,
					["g"] = 1,
					["b"] = 0,
				},
				["size"] = 35,
				["bgpadding"] = 11,
				["bordcolor"] = {
					["r"] = 1,
					["g"] = 1,
					["b"] = 1,
				},
				["attach"] = "Unit Frame",
				["bordercolor"] = {
					["b"] = 0,
					["g"] = 1,
					["r"] = 0.984314,
				},
				["alpha"] = 1,
				["yoffset"] = 0,
				["bgalpha"] = 1,
				["backgroundstyle"] = 3,
				["mouseovergroup"] = 1,
				["use3Dface"] = false,
				["xoffset"] = 0,
				["framestrata"] = "LOW",
				["use3D"] = false,
				["leftclick"] = 1,
			},
			["VoiceIcon"] = {
				["bgcolor"] = {
					["r"] = 1,
					["g"] = 1,
					["b"] = 1,
				},
				["borderalpha"] = 0,
				["framestrata"] = "LOW",
				["attachpoint"] = "TOPLEFT",
				["framelevel"] = 0,
				["middleclick"] = 2,
				["attachto"] = "TOPLEFT",
				["mouseovercolor"] = {
					["b"] = 0,
					["g"] = 1,
					["r"] = 1,
				},
				["size"] = 20,
				["bgpadding"] = 5,
				["attach"] = "Unit Frame",
				["bordercolor"] = {
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["alpha"] = 1,
				["yoffset"] = 0,
				["hide"] = false,
				["backgroundstyle"] = 2,
				["bgalpha"] = 1,
				["xoffset"] = 0,
				["rightclick"] = 3,
				["bgtexture"] = "VoiceChat-Speaker.tga",
				["leftclick"] = 1,
			},
			["backgroundstyle"] = 2,
			["width"] = 204,
			["bgcontext"] = 4,
			["LootIcon"] = {
				["bgcolor"] = {
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["borderalpha"] = 1,
				["rightclick"] = 3,
				["attachpoint"] = "CENTER",
				["framelevel"] = 0,
				["middleclick"] = 2,
				["attachto"] = "BOTTOMLEFT",
				["mouseovercolor"] = {
					["r"] = 1,
					["g"] = 1,
					["b"] = 0,
				},
				["hide"] = false,
				["bgpadding"] = 5,
				["textcolor"] = {
					["r"] = 0,
					["g"] = 1,
					["b"] = 0.968627,
				},
				["attach"] = "_Portrait",
				["bordercolor"] = {
					["b"] = 0,
					["g"] = 0.988235,
					["r"] = 1,
				},
				["alpha"] = 1,
				["yoffset"] = -2,
				["hidebg"] = 1,
				["size"] = 20,
				["bgalpha"] = 1,
				["xoffset"] = -4,
				["backgroundstyle"] = 2,
				["framestrata"] = "LOW",
				["leftclick"] = 1,
			},
			["mouseovergroup"] = 1,
			["connect"] = 1,
			["XPBar"] = {
				["recolor"] = false,
				["bgcolor"] = {
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["color"] = {
					["b"] = 1,
					["g"] = 0,
					["r"] = 1,
				},
				["bgalpha"] = 1,
				["alpha"] = 1,
				["width"] = 120,
				["yoffset"] = 0,
				["xoffset"] = 100,
				["height"] = 14,
				["bordercolor"] = {
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["hide"] = true,
			},
			["Buffs"] = {
				["durationy"] = -5,
				["bgcolor"] = {
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["borderalpha"] = 1,
				["rightclick"] = 3,
				["attachpoint"] = "TOPLEFT",
				["middleclick"] = 2,
				["tworows"] = 1,
				["background"] = false,
				["size"] = 13,
				["bgpadding"] = 5,
				["durationx"] = 0,
				["bordercolor"] = {
					["r"] = 0.984314,
					["g"] = 1,
					["b"] = 0,
				},
				["mouseover"] = false,
				["durationalpha"] = 1,
				["xoffset"] = 0,
				["yoffset"] = -6,
				["showduration"] = 1,
				["framelevel"] = 0,
				["vertical"] = false,
				["attachto"] = "BOTTOMLEFT",
				["mouseovercolor"] = {
					["r"] = 1,
					["g"] = 1,
					["b"] = 0,
				},
				["vspacing"] = 0,
				["durationcolor"] = {
					["r"] = 1,
					["g"] = 1,
					["b"] = 1,
				},
				["attach"] = "Unit Frame",
				["hspacing"] = 0,
				["backgroundstyle"] = 2,
				["durationheight"] = 6,
				["durationfont"] = "DUF_Font1.ttf",
				["spacing"] = 0,
				["altformat"] = 1,
				["alpha"] = 1,
				["bgalpha"] = 1,
				["shown"] = 16,
				["framestrata"] = "LOW",
				["leftclick"] = 1,
			},
			["leftclick"] = 1,
		}
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.3"]) then -- 5.3 Removal of Honor bar and Rank Icon
		DUF_Settings[DUF_INDEX].player.RankIcon = nil;
		DUF_Settings[DUF_INDEX].player.StatusBar[6] = {}; 
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.StatusBar[7], DUF_Settings[DUF_INDEX].player.StatusBar[6]);
		DUF_Settings[DUF_INDEX].player.StatusBar[7] = {}; 
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.StatusBar[8], DUF_Settings[DUF_INDEX].player.StatusBar[7]);
		DUF_Settings[DUF_INDEX].player.StatusBar[8] = {}; 
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.StatusBar[9], DUF_Settings[DUF_INDEX].player.StatusBar[8]);
		DUF_Settings[DUF_INDEX].player.StatusBar[9] = nil;

		DUF_Settings[DUF_INDEX].party.RankIcon = nil;
		DUF_Settings[DUF_INDEX].party.StatusBar[6] = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX].party.StatusBar[7], DUF_Settings[DUF_INDEX].party.StatusBar[6]);
		DUF_Settings[DUF_INDEX].partypet.RankIcon = nil;
		DUF_Settings[DUF_INDEX].partypet.StatusBar[6] = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX].partypet.StatusBar[7], DUF_Settings[DUF_INDEX].partypet.StatusBar[6]);
		DUF_Settings[DUF_INDEX].target.RankIcon = nil;
		DUF_Settings[DUF_INDEX].target.StatusBar[6] = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX].target.StatusBar[7], DUF_Settings[DUF_INDEX].target.StatusBar[6]);
		DUF_Settings[DUF_INDEX].targettarget.RankIcon = nil;
		DUF_Settings[DUF_INDEX].targettarget.StatusBar[6] = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX].targettarget.StatusBar[7], DUF_Settings[DUF_INDEX].targettarget.StatusBar[6]);
		DUF_Settings[DUF_INDEX].focus.RankIcon = nil;
		DUF_Settings[DUF_INDEX].focus.StatusBar[6] = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX].focus.StatusBar[7], DUF_Settings[DUF_INDEX].focus.StatusBar[6]);
		DUF_Settings[DUF_INDEX].boss.RankIcon = nil;
		DUF_Settings[DUF_INDEX].boss.StatusBar[6] = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX].boss.StatusBar[7], DUF_Settings[DUF_INDEX].boss.StatusBar[6]);
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.4"]) then -- 5.4 Missed settings for Pet stausbar update
		DUF_Settings[DUF_INDEX].pet.RankIcon = nil;
		DUF_Settings[DUF_INDEX].pet.StatusBar[6] = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX].pet.StatusBar[7], DUF_Settings[DUF_INDEX].pet.StatusBar[6]);
		DUF_Settings[DUF_INDEX].pet.StatusBar[7] = nil;
		DUF_Settings[DUF_INDEX].party.StatusBar[7] = nil;
		DUF_Settings[DUF_INDEX].partypet.StatusBar[6] = nil;
		DUF_Settings[DUF_INDEX].target.StatusBar[7] = nil;
		DUF_Settings[DUF_INDEX].targettarget.StatusBar[7] = nil;
		DUF_Settings[DUF_INDEX].focus.StatusBar[7] = nil;
		DUF_Settings[DUF_INDEX].boss.StatusBar[7] = nil;
	end
	
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.5"]) then
		DUF_Settings[DUF_INDEX].player["EclipseFrame"] = {
			["bgcolor"] = {
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["borderalpha"] = 1,
			["rightclick"] = 3,
			["attachpoint"] = "CENTER",
			["middleclick"] = 2,
			["attachto"] = "BOTTOMRIGHT",
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["size"] = 25,
			["bgpadding"] = 0,
			["attach"] = "_Portrait",
			["bordercolor"] = {
				["r"] = 0.996078,
				["g"] = 1,
				["b"] = 0,
			},
			["alpha"] = 1,
			["width"] = 110,
			["leftclick"] = 1,
			["backgroundstyle"] = 2,
			["xoffset"] = 88,
			["height"] = 12,
			["bgalpha"] = 1,
			["hidebg"] = 1,
			["yoffset"] = 44,
		};
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.6"]) then -- 5.6 Missed settings for PartyPet castbar update
		if (DUF_Settings[DUF_INDEX].partypet.StatusBar[7] and not DUF_Settings[DUF_INDEX].partypet.StatusBar[6]) then
			DUF_Settings[DUF_INDEX].partypet.StatusBar[6] = {}
			DL_Copy_Table(DUF_Settings[DUF_INDEX].partypet.StatusBar[7], DUF_Settings[DUF_INDEX].partypet.StatusBar[6]);
			DUF_Settings[DUF_INDEX].partypet.StatusBar[7] = nil;
		end
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.7"]) then -- 5.7 Fixed setting for Warlock Demo bar
		if not DUF_Settings[DUF_INDEX].player.StatusBar[8].color then
			if DUF_Settings[DUF_INDEX].player.StatusBar[8].manacolor then
				DUF_Settings[DUF_INDEX].player.StatusBar[8].color= {}
				DL_Copy_Table(DUF_Settings[DUF_INDEX].player.StatusBar[8].manacolor, DUF_Settings[DUF_INDEX].player.StatusBar[8].color)
			else
				DUF_Settings[DUF_INDEX].player.StatusBar[8].color = {
					["b"] = 0.592156862745098,
					["g"] = 0,
					["r"] = 0.4980392156862745,
				};
			end
		end
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.8"]) then -- 5.8 Adding Anticipation points
		DUF_Settings[DUF_INDEX].target.AnticipationPoints = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].target.ComboPoints, DUF_Settings[DUF_INDEX].target.AnticipationPoints)
		DUF_Settings[DUF_INDEX].target.AnticipationPoints.color.r = 0
		DUF_Settings[DUF_INDEX].target.AnticipationPoints.color.g = 0
		DUF_Settings[DUF_INDEX].target.AnticipationPoints.color.b = 1
		DUF_Settings[DUF_INDEX].target.AnticipationPoints.size = DUF_Settings[DUF_INDEX].target.ComboPoints.size - 6
		DUF_Settings[DUF_INDEX].target.AnticipationPoints.yoffset = DUF_Settings[DUF_INDEX].target.ComboPoints.yoffset + 3
		DUF_Settings[DUF_INDEX].target.AnticipationPoints.spacing = DUF_Settings[DUF_INDEX].target.ComboPoints.spacing + 6
		if DUF_Settings[DUF_INDEX].target.ComboPoints.framelevel then
			DUF_Settings[DUF_INDEX].target.AnticipationPoints.framelevel = DUF_Settings[DUF_INDEX].target.ComboPoints.framelevel + 1
		else
			DUF_Settings[DUF_INDEX].target.AnticipationPoints.framelevel = 1
		end
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.9"]) then -- 5.9 Adding adding class bar OOC alpha
		DUF_Settings[DUF_INDEX].player["EclipseFrame"].oocalpha = 1
		DUF_Settings[DUF_INDEX].player["MonkHarmony"].oocalpha = 1
		DUF_Settings[DUF_INDEX].player["PalyPowerFrame"].oocalpha = 1
		DUF_Settings[DUF_INDEX].player["PriestOrbFrame"].oocalpha = 1
		DUF_Settings[DUF_INDEX].player["RuneFrame"].oocalpha = 1
		DUF_Settings[DUF_INDEX].player["WarlockPowerFrame"].oocalpha = 1
		DUF_Settings[DUF_INDEX].player.StatusBar[8].oocalpha = 1
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.10"]) then -- 5.10 Adding Default Attach point Maybe being able to hide buff stacks
		DUF_Settings[DUF_INDEX].player.attachpoint = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].player.attachto = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].pet.attachpoint = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].pet.attachto = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].target.attachpoint = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].target.attachto = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].targettarget.attachpoint = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].targettarget.attachto = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].focus.attachpoint = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].focus.attachto = {"TOPLEFT"}
		DUF_Settings[DUF_INDEX].party.attachpoint = {"TOPLEFT", "TOPLEFT", "TOPLEFT", "TOPLEFT"}
		DUF_Settings[DUF_INDEX].party.attachto = {"TOPLEFT", "TOPLEFT", "TOPLEFT", "TOPLEFT"}
		DUF_Settings[DUF_INDEX].partypet.attachpoint = {"TOPLEFT", "TOPLEFT", "TOPLEFT", "TOPLEFT"}
		DUF_Settings[DUF_INDEX].partypet.attachto = {"TOPLEFT", "TOPLEFT", "TOPLEFT", "TOPLEFT"}
		DUF_Settings[DUF_INDEX].boss.attachpoint = {"TOPLEFT", "TOPLEFT", "TOPLEFT", "TOPLEFT", "TOPLEFT"}
		DUF_Settings[DUF_INDEX].boss.attachto = {"TOPLEFT", "TOPLEFT", "TOPLEFT", "TOPLEFT", "TOPLEFT"}
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.11"]) then -- Adding target markers.
		DUF_Settings[DUF_INDEX].target.Markers = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].target.ClassIcon, DUF_Settings[DUF_INDEX].target.Markers) -- copt setting from class icon
		DUF_Settings[DUF_INDEX].target.Markers.width = DUF_Settings[DUF_INDEX].target.Markers.size
		DUF_Settings[DUF_INDEX].target.Markers.height = DUF_Settings[DUF_INDEX].target.Markers.size
		DUF_Settings[DUF_INDEX].target.Markers.markersize = DUF_Settings[DUF_INDEX].target.Markers.size
		DUF_Settings[DUF_INDEX].target.Markers.size = nil
		DUF_Settings[DUF_INDEX].target.Markers.xos = {[1]=0, [2]=DUF_Settings[DUF_INDEX].target.ClassIcon.size, [3]=DUF_Settings[DUF_INDEX].target.ClassIcon.size * 2, [4]=DUF_Settings[DUF_INDEX].target.ClassIcon.size * 3, [5]=DUF_Settings[DUF_INDEX].target.ClassIcon.size * 4, [6]=DUF_Settings[DUF_INDEX].target.ClassIcon.size * 5, [7]=DUF_Settings[DUF_INDEX].target.ClassIcon.size * 6, [8]=DUF_Settings[DUF_INDEX].target.ClassIcon.size * 7}
		DUF_Settings[DUF_INDEX].target.Markers.yos = {[1]=0, [2]=0, [3]=0, [4]=0, [5]=0, [6]=0, [7]=0, [8]=0}
		DUF_Settings[DUF_INDEX].target.Markers.icons = {}
		DUF_Settings[DUF_INDEX].target.Markers.icons[1] = {file="interface\\targetingframe\\ui-raidtargetingicons", left=0, right=.25, top=0, bottom=.25}
		DUF_Settings[DUF_INDEX].target.Markers.icons[2] = {file="interface\\targetingframe\\ui-raidtargetingicons", left=.25, right=.5, top=0, bottom=.25}
		DUF_Settings[DUF_INDEX].target.Markers.icons[3] =  {file="interface\\targetingframe\\ui-raidtargetingicons", left=.5, right=.75, top=0, bottom=.25}
		DUF_Settings[DUF_INDEX].target.Markers.icons[4] =  {file="interface\\targetingframe\\ui-raidtargetingicons", left=.75, right=1, top=0, bottom=.25}
		DUF_Settings[DUF_INDEX].target.Markers.icons[5] =  {file="interface\\targetingframe\\ui-raidtargetingicons", left=0, right=.25, top=.25, bottom=.5}
		DUF_Settings[DUF_INDEX].target.Markers.icons[6] =  {file="interface\\targetingframe\\ui-raidtargetingicons", left=.25, right=.5, top=.25, bottom=.5}
		DUF_Settings[DUF_INDEX].target.Markers.icons[7] =  {file="interface\\targetingframe\\ui-raidtargetingicons", left=.5, right=.75, top=.25, bottom=.5}
		DUF_Settings[DUF_INDEX].target.Markers.icons[8] =  {file="interface\\targetingframe\\ui-raidtargetingicons", left=.75, right=1, top=.25, bottom=.5}
		DUF_Settings[DUF_INDEX].target.Markers.yoffset = DUF_Settings[DUF_INDEX].target.Markers.yoffset - 20 -- and move down 20
	end
	
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED6.0"]) then -- Adding QuestBoss markers.
		DUF_Settings[DUF_INDEX].target.QuestBossIcon = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].target.RoleIcon, DUF_Settings[DUF_INDEX].target.QuestBossIcon)
		DUF_Settings[DUF_INDEX].target.QuestBossIcon.texture = "Interface\\TargetingFrame\\PortraitQuestBadge"
		for _, unit in pairs(DUF_FRAME_INDICES) do
			DUF_Settings[DUF_INDEX][unit].PhaseIcon = {}
			DL_Copy_Table(DUF_Settings[DUF_INDEX][unit].StatusIcon, DUF_Settings[DUF_INDEX][unit].PhaseIcon)
			DUF_Settings[DUF_INDEX][unit].PhaseIcon.xoffset = DUF_Settings[DUF_INDEX][unit].PhaseIcon.xoffset + DUF_Settings[DUF_INDEX][unit].PhaseIcon.size
			DUF_Settings[DUF_INDEX][unit].PhaseIcon.hide = true
		end
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED6.1"]) then -- Adding player frame combo/Ant. points.
		DUF_Settings[DUF_INDEX].player.ComboPoints = {}
		DUF_Settings[DUF_INDEX].player.AnticipationPoints = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].target.ComboPoints, DUF_Settings[DUF_INDEX].player.ComboPoints)
		DL_Copy_Table(DUF_Settings[DUF_INDEX].target.AnticipationPoints, DUF_Settings[DUF_INDEX].player.AnticipationPoints)
		DUF_Settings[DUF_INDEX].player.ComboPoints.hide = true
		DUF_Settings[DUF_INDEX].player.AnticipationPoints.hide = true
		DUF_Settings[DUF_INDEX].player.ComboPoints.oocalpha = DUF_Settings[DUF_INDEX].player.RuneFrame.oocalpha
		DUF_Settings[DUF_INDEX].player.AnticipationPoints.oocalpha = DUF_Settings[DUF_INDEX].player.RuneFrame.oocalpha
		DUF_Settings[DUF_INDEX].player.ComboPoints.attachpoint = DUF_Settings[DUF_INDEX].player.RuneFrame.attachpoint
		DUF_Settings[DUF_INDEX].player.AnticipationPoints.attachpoint = DUF_Settings[DUF_INDEX].player.RuneFrame.attachpoint
		DUF_Settings[DUF_INDEX].player.ComboPoints.attach = DUF_Settings[DUF_INDEX].player.RuneFrame.attach
		DUF_Settings[DUF_INDEX].player.AnticipationPoints.attach = DUF_Settings[DUF_INDEX].player.RuneFrame.attach
		DUF_Settings[DUF_INDEX].player.ComboPoints.xoffset = DUF_Settings[DUF_INDEX].player.RuneFrame.xoffset
		DUF_Settings[DUF_INDEX].player.AnticipationPoints.xoffset = DUF_Settings[DUF_INDEX].player.RuneFrame.xoffset
		DUF_Settings[DUF_INDEX].player.ComboPoints.attachto = DUF_Settings[DUF_INDEX].player.RuneFrame.attachto
		DUF_Settings[DUF_INDEX].player.AnticipationPoints.attachto = DUF_Settings[DUF_INDEX].player.RuneFrame.attachto
		DUF_Settings[DUF_INDEX].player.ComboPoints.yoffset = DUF_Settings[DUF_INDEX].player.RuneFrame.yoffset
		DUF_Settings[DUF_INDEX].player.AnticipationPoints.yoffset = DUF_Settings[DUF_INDEX].player.RuneFrame.yoffset
	end

	if not DUF_Settings[DUF_INDEX]["INITIALIZED7.0"] then -- Adding updated class bar for Legion.
		for _,v in pairs(DUF_FRAME_INDICES) do
			DUF_Settings[DUF_INDEX][v].TempEnchants_1 = nil
			DUF_Settings[DUF_INDEX][v].TempEnchants_2 = nil
		end
	
		for _,v in pairs(DUF_FRAME_INDICES) do
			DUF_Settings[DUF_INDEX][v].StatusBar[2].insanitycolor = { r=0.40, g=0, b=0.80, }
			DUF_Settings[DUF_INDEX][v].StatusBar[5].insanitycolor = { r=0.40, g=0, b=0.80, }
			DUF_Settings[DUF_INDEX][v].StatusBar[2].lunarpowercolor = { r=0.30, g=0.52, b=0.90, }
			DUF_Settings[DUF_INDEX][v].StatusBar[5].lunarpowercolor = { r=0.30, g=0.52, b=0.90, }
			DUF_Settings[DUF_INDEX][v].StatusBar[2].maelstrompower = { r = 0.00, g = 0.50, b = 1.00, }
			DUF_Settings[DUF_INDEX][v].StatusBar[5].maelstrompower = { r = 0.00, g = 0.50, b = 1.00, }
		end
		DUF_Settings[DUF_INDEX].player.StatusBar[7].runicpowercolor = nil
		DUF_Settings[DUF_INDEX].player.StatusBar[7].focuscolor = nil
	
	---- ROGUE
		local settings
		DUF_Settings[DUF_INDEX].player.ROGUE = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.ComboPoints, DUF_Settings[DUF_INDEX].player.ROGUE)
		DUF_Settings[DUF_INDEX].player.ComboPoints = nil
		settings = DUF_Settings[DUF_INDEX].player.ROGUE
		settings.width = settings.size
		settings.height = settings.size
		settings.sizelock = true
		if settings.vertical then
			settings.direction = 4
		else
			settings.direction = 1
		end
		settings.vertical = nil
		settings.borders = {} -- element border
		settings.textures = {} -- element
		settings.numtextures = 0
		if DUF_CLASS_CENTERS[settings.attachto] then
			settings.centeralign = true
		end
		if settings.customtexture then
			settings.numtextures = 1
			settings.textures[1] = {
				texture = settings.customtexture,
				level = "ARTWORK",
				defaultcolor = true,
				color = settings.color,
			}
		end
		settings.size = nil
		settings.customtexture = nil
	
	---- DRUID
		DUF_Settings[DUF_INDEX].player.DRUID = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.ROGUE, DUF_Settings[DUF_INDEX].player.DRUID)
	
	---- PALADIN
		DUF_Settings[DUF_INDEX].player.PALADIN = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.PalyPowerFrame, DUF_Settings[DUF_INDEX].player.PALADIN)
		DUF_Settings[DUF_INDEX].player.PalyPowerFrame = nil
		settings = DUF_Settings[DUF_INDEX].player.PALADIN
		settings.width = settings.size
		settings.height = settings.size
		settings.sizelock = true
		settings.numtextures = 0
		if settings.vertical then
			settings.direction = 4
		else
			settings.direction = 1
		end
		settings.vertical = nil
		settings.borders = {} -- element border
		settings.textures = {} -- element
		if DUF_CLASS_CENTERS[settings.attachto] then
			settings.centeralign = true
		end
	
		settings.size = nil
		settings.customtexture = nil
	
	---- MONK
		DUF_Settings[DUF_INDEX].player.MONK = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.MonkHarmony, DUF_Settings[DUF_INDEX].player.MONK )
		DUF_Settings[DUF_INDEX].player.MonkHarmony = nil
		settings = DUF_Settings[DUF_INDEX].player.MONK
		settings.width = settings.size
		settings.height = settings.size
		settings.sizelock = true
		settings.color={ r=1, g=1, b=1 } 
		settings.color2 = settings.color
		settings.numtextures = 0
		if DUF_CLASS_CENTERS[settings.attachto] then
			settings.centeralign = true
		end
		if settings.vertical then
			settings.direction = 4
		else
			settings.direction = 1
		end
		settings.vertical = nil
		settings.borders = {} -- element border
		settings.textures = {} -- element
		settings.size = nil
		settings.customtexture = nil
	
	-- MONK Stagger
		DUF_Settings[DUF_INDEX].player["MONK"..SPEC_MONK_BREWMASTER] = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.MONK, DUF_Settings[DUF_INDEX].player["MONK"..SPEC_MONK_BREWMASTER])
		settings = DUF_Settings[DUF_INDEX].player["MONK"..SPEC_MONK_BREWMASTER]
		settings.width = DUF_Settings[DUF_INDEX].player.StatusBar[2].width
		settings.height = DUF_Settings[DUF_INDEX].player.StatusBar[2].height
		if settings.width < 10 then
			settings.width = 10
		end
		if settings.height < 10 then
			settings.height = 10
		end
		settings.sizelock = nil
		settings.numtextures = 1
		settings.backgroundstyle = 2
		settings.hidebg = false
		settings.bgpadding = 5
		settings.borderalpha = 0.65
		settings.color = {
			r = 0.501960784313726,
			g = 0.615686274509804,
			b = 1,
		}
		settings.bordercolor = {
			b = 0.584313725490196,
			g = 0.796078431372549,
			r = 0.945098039215686,
		}
		settings.bgcolor = {
			r = 0.211764705882353,
			g = 0.219607843137255,
			b = 0.470588235294118,
		}
		settings.bgsize = {
			height = 16,
			width = 12,
		}
		settings.textures[1] = {
			texture = "bg0",
			level = "ARTWORK",
	--		defaultcolor = false,
	--		color = { r=0, g=0, b=1 },
		}
	
	---- MAGE
		DUF_Settings[DUF_INDEX].player.MAGE = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.PALADIN, DUF_Settings[DUF_INDEX].player.MAGE)
		DUF_Settings[DUF_INDEX].player.MAGE.width = 30
		DUF_Settings[DUF_INDEX].player.MAGE.height = 30
	
	---- DEATHKNIGHT
		DUF_Settings[DUF_INDEX].player.DEATHKNIGHT = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.RuneFrame, DUF_Settings[DUF_INDEX].player.DEATHKNIGHT)
		DUF_Settings[DUF_INDEX].player.RuneFrame = nil
		settings = DUF_Settings[DUF_INDEX].player.DEATHKNIGHT
		settings.width = settings.size
		settings.height = settings.size
		settings.sizelock = true
		settings.numtextures = 0
		if settings.vertical then
			settings.direction = 4
		else
			settings.direction = 1
		end
		settings.vertical = nil
		settings.borders = {} -- element border
		settings.textures = {} -- element
		if DUF_CLASS_CENTERS[settings.attachto] then
			settings.centeralign = true
		end
		settings.size = nil
		settings.customtexture = nil
	
	---- WARLOCK
		DUF_Settings[DUF_INDEX].player.WARLOCK = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.WarlockPowerFrame, DUF_Settings[DUF_INDEX].player.WARLOCK)
		DUF_Settings[DUF_INDEX].player.WarlockPowerFrame = nil
		settings = DUF_Settings[DUF_INDEX].player.WARLOCK
		settings.width = settings.size
		settings.height = settings.size
		settings.sizelock = true
		settings.numtextures = 0
		if settings.vertical then
			settings.direction = 4
		else
			settings.direction = 1
		end
		settings.vertical = nil
		settings.borders = {} -- element border
		settings.textures = {} -- element
		if DUF_CLASS_CENTERS[settings.attachto] then
			settings.centeralign = true
		end
		settings.size = nil
		settings.customtexture = nil
	
	---- CLEANUP
		DUF_Settings[DUF_INDEX].player.AnticipationPoints = nil
		DUF_Settings[DUF_INDEX].target.ComboPoints = nil
		DUF_Settings[DUF_INDEX].target.AnticipationPoints = nil
		DUF_Settings[DUF_INDEX].player.PriestOrbFrame = nil
		DUF_Settings[DUF_INDEX].player.EclipseFrame = nil
		DUF_Settings[DUF_INDEX].player.TextBox[12] = nil -- WoD Warlock text
		DUF_Settings[DUF_INDEX].player.StatusBar[8] = nil -- WoD Warlock statusbar
	end

	if not DUF_Settings[DUF_INDEX]["INITIALIZED7.0a"] then
		DUF_Settings[DUF_INDEX].classcolorDemonHunter = {
			["r"] = 0.64,
			["g"] = 0.19,
			["b"] = 0.79,
		}
	end
	if not DUF_Settings[DUF_INDEX]["INITIALIZED7.0b"] then
		DUF_Settings[DUF_INDEX].player.TotemFrame = {}
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.MAGE, DUF_Settings[DUF_INDEX].player.TotemFrame)
		DUF_Settings[DUF_INDEX].player.TotemFrame.scale = 1
	end	
	
	if not DUF_Settings[DUF_INDEX]["INITIALIZED7.0c"] then -- Adding updated class bar for Legion.
		for k,v in pairs(DUF_FRAME_INDICES) do
			if not DUF_Settings[DUF_INDEX][v].StatusBar[2].insanitycolor then
				DUF_Settings[DUF_INDEX][v].StatusBar[2].insanitycolor = { r=0.40, g=0, b=0.80, }
			end
			if not DUF_Settings[DUF_INDEX][v].StatusBar[5].insanitycolor then
				DUF_Settings[DUF_INDEX][v].StatusBar[5].insanitycolor = { r=0.40, g=0, b=0.80, }
			end
			if not DUF_Settings[DUF_INDEX][v].StatusBar[2].lunarpowercolor then
				DUF_Settings[DUF_INDEX][v].StatusBar[2].lunarpowercolor = { r=0.30, g=0.52, b=0.90, }
			end
			if not DUF_Settings[DUF_INDEX][v].StatusBar[5].lunarpowercolor then
				DUF_Settings[DUF_INDEX][v].StatusBar[5].lunarpowercolor = { r=0.30, g=0.52, b=0.90, }
			end
			if not DUF_Settings[DUF_INDEX][v].StatusBar[2].maelstrompower then
				DUF_Settings[DUF_INDEX][v].StatusBar[2].maelstrompower = { r = 0.00, g = 0.50, b = 1.00, }
			end
			if not DUF_Settings[DUF_INDEX][v].StatusBar[5].maelstrompower then
				DUF_Settings[DUF_INDEX][v].StatusBar[5].maelstrompower = { r = 0.00, g = 0.50, b = 1.00, }
			end
		end
	end
	if not DUF_Settings[DUF_INDEX]["INITIALIZED7.2"] then -- Removing Voice Icon as an attach
		local function FrameMoved(unit, frame)
			print("Voice Icon Removed:\n", unit, frame, "now attached to Unit Frame")
		end
		local elementList = {}
		DL_Copy_Table(DUF_ELEMENT_INDICES, elementList)
		tinsert(elementList, "EliteTexture")
		tinsert(elementList, "Markers")
		tinsert(elementList, "XPBar")
		tinsert(elementList, "QuestBossIcon")
		for _,unit in pairs(DUF_FRAME_INDICES) do
			for _, frame in pairs(elementList) do
				if frame ~= "TextBox" and frame ~= "StatusBar" then
					if DUF_Settings[DUF_INDEX][unit][frame] and DUF_Settings[DUF_INDEX][unit][frame].attach and find(DUF_Settings[DUF_INDEX][unit][frame].attach, "_VoiceIcon") then
						FrameMoved(unit, frame)
						DUF_Settings[DUF_INDEX][unit][frame].attach = "Unit Frame"
					end
				end
			end
			for i=1, #DUF_Settings[DUF_INDEX][unit].StatusBar do
				if DUF_Settings[DUF_INDEX][unit].StatusBar[i] and DUF_Settings[DUF_INDEX][unit].StatusBar[i].attach and find(DUF_Settings[DUF_INDEX][unit].StatusBar[i].attach, "_VoiceIcon") then
					FrameMoved(unit, "StatusBar"..i)
					DUF_Settings[DUF_INDEX][unit].StatusBar[i].attach = "Unit Frame"
				end
			end
			for i=1, #DUF_Settings[DUF_INDEX][unit].TextBox do
				if DUF_Settings[DUF_INDEX][unit].TextBox[i] and DUF_Settings[DUF_INDEX][unit].TextBox[i].attach and find(DUF_Settings[DUF_INDEX][unit].TextBox[i].attach, "_VoiceIcon") then
					FrameMoved(unit, "TextBox"..i)
					DUF_Settings[DUF_INDEX][unit].TextBox[i].attach = "Unit Frame"
				end
			end
		end
	end
	
-- *** Copy the latest init. setting to the function at the bottom ***
	DUF_Settings[DUF_INDEX]["INITIALIZED7.2"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED7.0c"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED7.0b"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED7.0a"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED7.0"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED6.1"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED6.0"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.11"] = true; --Fizzlemizz
	DUF_Settings[DUF_INDEX]["INITIALIZED5.10"] = true; --Fizzlemizz
	DUF_Settings[DUF_INDEX]["INITIALIZED5.9"] = true; --Fizzlemizz
	DUF_Settings[DUF_INDEX]["INITIALIZED5.8"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.7"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.6"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.5"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.4"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.3"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.2"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.1"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.0c"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.0b"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.0a"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.0"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED4.18"] = true; --Fizzlemizz
	DUF_Settings[DUF_INDEX]["INITIALIZED4.17"] = true; --Fizzlemizz
	DUF_Settings[DUF_INDEX]["INITIALIZED4.1a"] = true; --Fizzlemizz
	DUF_Settings[DUF_INDEX]["INITIALIZED4.0a"] = true; --Fizzlemizz
	DUF_Settings[DUF_INDEX]["INITIALIZED4.0"] = true; --Fizzlemizz
	DUF_Settings[DUF_INDEX]["INITIALIZED3.1.0a"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED3.0.3a"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.4"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.3x"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.3w"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.3u"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.3t"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.3s"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.2c"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.2"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.1"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.0f"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.0"] = true;
end

function _DUF:DUF_Initialize_NewSettings()
--print("NOTE:  INITIALIZED7.0c = true commented out in NewSettings!!!!!")
	if DUF_Settings[DUF_INDEX]["INITIALIZED7.2"] then return end
	Update_All_NewSettings()
end
